%Edit IP address here
ip = '172.21.64.40';

%transmitted measuring channels
maxchannels = 1;

%transmitted time channels
timechannels = 1;

%Sets up the measurement
sock = doSetup(ip);

%Start measurement for group 0
data1 = sendC(sock, 'TSV0');

%clock for measurement - change endtime for measurement duration
acttime = clock;
endtime = acttime(6) + 10;

%Calculation of memory requirement of a line
datalineb = maxchannels*4 + timechannels*8;

%Value and time arrays (need to be added, if more signals are transmitted)
recValues1 = [];
recValues2 = [];
recNTP = [];

values = [[];[]];



while acttime(6) < endtime
    i=0;
    data1 = sendC(sock, 'OMP? 0');
    data1 = split(data1, ',');
    lines = data1(1);
    msrmode = str2double(data1(2));
    if msrmode == 1
       if str2double(lines) > 0
           am = 4+(str2double(lines{1,1})*datalineb);
           data = sendCData(sock, char(strcat('RMB?', lines, ',6409,0')), am);
           noOfDataLines = (length(data)-4) / datalineb;
           bytePos = 3;
           
           for dataline = 1:1:(noOfDataLines)
                %{Read Measurement Values}%
                %Read Measurement Value1
                valueBuff = data(bytePos:(bytePos + 3));
                a = uint8(valueBuff);
                val = typecast(a, 'single');
                recValues1 = [recValues1 val];
                bytePos = bytePos + 4;
                   
                %Read Measurement Value2
                %valueBuff = data(bytePos:(bytePos + 3));
                %a = uint8(valueBuff);
                %val = typecast(a, 'single');
                %recValues2 = [recValues2 val];
                %bytePos = bytePos + 4;
                
                %Add more measurement values here
                
                %{Read Time}%
                
                %%Optional Block to get the time in ticks (STF needs to be
                %%set to 0)
                %Get 64bit time
                %valueBuff = data(bytePos:(bytePos + 7));
                %a = uint8(valueBuff);
                %time = typecast(a, 'uint64');
                %time = double(time);
                %time = time*10^(-5);
                %bytePos = bytePos + 8;
                
                %Get ms time
                valueBuff = data(bytePos:(bytePos + 3));
                a = uint8(valueBuff);
                timems = typecast(a, 'uint32');
                bytePos = bytePos + 4;
                
                %Get s time
                valueBuff = data(bytePos:(bytePos + 3));
                a = uint8(valueBuff);
                times = typecast(a, 'uint32');
                bytePos = bytePos + 4;

                %Get doubles
                timems = double(timems);
                times = double(times);
                
                %Get exact time in s
                timems = timems*10^(-6);
                time = timems + times;
                
                %Add time to timearray
                recNTP = [recNTP time];
           end 
       end
    end
    acttime = clock;
end

recNTPnew = recNTP - recNTP(1);

figure
hold on
plot(recNTPnew, recValues1)
%plot(recNTPnew, recValues2)

grid on
xlabel('time in s')
ylabel('value')

delete(sock);